#include <ecat.h>

#define ROBOT_ATURAT      0
#define ROBOT_ENDAVANT    1
#define ROBOT_ENDARRERA   2
#define ROBOT_DRETA       3
#define ROBOT_ESQUERRA    4

String szMissatge;
Ecat ecat;
boolean bConnectat;
int nG,nA,nB,nEstatActual;

void setup(){
  ecat.setupNibbleMode(NIBBLE_H_P1,OUTPUT);
  //ecat.vUltrasonicSensorP1b0b1_init();
  pinMode(ecat.nPinP1B2,INPUT);
  pinMode(ecat.nPinP1B3,INPUT);
 // pinMode(ecat.nPinP2B7,OUTPUT);
  //pinMode(ecat.nPinP2B6,INPUT);
  //pinMode(ecat.nPinP2B5,INPUT);
  //pinMode(ecat.nPinP2B4,INPUT);
  //ecat.setupNibbleMode(NIBBLE_L_P2,INPUT);
  Serial.begin(9600);
  nG = 150;
  nA = nB = 30;
  bConnectat = false;
  nEstatActual = ROBOT_ATURAT;
}

int nPwmA(){
  int nAux = nG + nA;
  if(nAux > 255)
    nAux = 255;
  return nAux;
}

int nPwmB(){
  int nAux = nG + nB;
  if(nAux > 255)
    nAux = 255;
  return nAux;
}

void vRobotAturat(){
  nEstatActual = ROBOT_ATURAT;
  ecat.vWriteHighNibbleP1(0x00);
}

void vRobotEndavant(){
  //ecat.vWriteHighNibbleP1(B00000110);
  nEstatActual = ROBOT_ENDAVANT;
  digitalWrite(ecat.nPinP1B4,LOW);
  analogWrite(ecat.nPinP1B5,nPwmA());
  analogWrite(ecat.nPinP1B6,nPwmB());
  digitalWrite(ecat.nPinP1B7,LOW);
}

void vRobotEndarrera(){
  nEstatActual = ROBOT_ENDARRERA;
  ecat.vWriteHighNibbleP1(B00001001);
}

void vRobotEsquerra(){
  //ecat.vWriteHighNibbleP1(B00000101);
  nEstatActual = ROBOT_ESQUERRA;
  digitalWrite(ecat.nPinP1B4,LOW);
  analogWrite(ecat.nPinP1B5,LOW);
  analogWrite(ecat.nPinP1B6,nPwmB());
  digitalWrite(ecat.nPinP1B7,LOW);
}

void vRobotDreta(){
  //ecat.vWriteHighNibbleP1(B00001010);
  nEstatActual = ROBOT_DRETA;
  digitalWrite(ecat.nPinP1B4,LOW);
  analogWrite(ecat.nPinP1B5,nPwmA());
  analogWrite(ecat.nPinP1B6,LOW);
  digitalWrite(ecat.nPinP1B7,LOW);
}

void vRobot(int nEe){
  switch(nEe){
    case ROBOT_ENDAVANT: vRobotEndavant();
                   break;
    case ROBOT_ESQUERRA: vRobotEsquerra();
                   break;
    case ROBOT_DRETA: vRobotDreta();
                   break;
    case ROBOT_ENDARRERA: vRobotEndarrera();
                   break;
    default : vRobotAturat();
  }
}

/*void vInformaSensors(){
  int nDist = ecat.nUsDistanceCmP1b0b1();

  if(nDist >= 0){
    szMissatge = "<" + String(nDist) + ">";
  }
  szMissatge += "[";
  szMissatge += (digitalRead(ecat.nPinP1B2))?"R":"r";
  szMissatge += (digitalRead(ecat.nPinP1B3))?"L":"l";
  szMissatge += (digitalRead(ecat.nPinP2B0))?"Z":"z";
  szMissatge += (digitalRead(ecat.nPinP2B1))?"U":"u";
  szMissatge += (digitalRead(ecat.nPinP2B2))?"D":"d";
  szMissatge += (digitalRead(ecat.nPinP2B3))?"T":"t";
  szMissatge += (digitalRead(ecat.nPinP2B4))?"Q":"q";
  szMissatge += (digitalRead(ecat.nPinP2B5))?"C":"c";
  szMissatge += (digitalRead(ecat.nPinP2B6))?"S":"s";
  szMissatge += "]";
  Serial.println(szMissatge);
  szMissatge = "";
}*/

void vSlider(String szSl){
  int nIndex,nIndexAux,nEprev;
  String sz;
  
  nIndex = szMissatge.indexOf(szSl);
  if(nIndex != -1){
    nIndexAux = szMissatge.indexOf('>',nIndex+1);
    if(nIndexAux != -1){
      if(nEstatActual != ROBOT_ATURAT){
        nEprev = nEstatActual;
        vRobotAturat();
        vRobot(nEprev);
      }
      sz = szMissatge.substring(nIndex+4,nIndexAux);
      if(szSl == "<slG")
        nG = sz.toInt();
      if(szSl == "<slA")
        nA = sz.toInt();
      if(szSl == "<slB")
        nB = sz.toInt();
    }
  }
}

void vSliders(){
  vSlider("<slG");
  vSlider("<slA");
  vSlider("<slB");
}

void vManageMsg(){
  vSliders();
  if(szMissatge == "on"){
    //digitalWrite(ecat.nPinP2B7,HIGH);
    bConnectat = true;
    analogWrite(ecat.nPinP2B7,nG);
  }
  if(szMissatge == "off"){
    bConnectat = false;
    digitalWrite(ecat.nPinP2B7,LOW);
  }
  /*if(szMissatge == "ask"){
    bConnectat = true;
    vInformaSensors();
  }*/
  if(szMissatge == "fw" && bConnectat ){
    vRobotEndavant();
  }
  if(szMissatge == "bw" && bConnectat  ){
    vRobotEndarrera();
  }
  if(szMissatge == "st"){
    vRobotAturat();
  }
  if(szMissatge == "le" && bConnectat ){
    vRobotEsquerra();
  }
  if(szMissatge == "ri" && bConnectat ){
    vRobotDreta();
  }
}

void loop(){
  while(Serial.available()){
    delay(3);
    char c = Serial.read();
    Serial.write(c);
    szMissatge += c;
  }
  vManageMsg();
  szMissatge = "";  
}


